def proc calc_ysize (y_csize%)
rem This tries to calculate the window y size depending on the given y size,
rem the number of rows wished in the menu appsub window and the y position of
rem the menu appsub window.
rem It uses and changes the GLOBAL variables rows%, app_y_orig% and ysize%.
rem It also uses the GLOBAL var maxy% which is the maximum y size a window
rem could have in the current screen resolution.
rem algo is as follows:
rem if both ysize and rows% are undefined (=-1) : make wdw as big as possible
rem if one is undefined, calc the other
rem if both are defined, give precedence to the rows number
rem
rem param : y_csize% is the y character height, either 0 (10 pix) or 1 (20 pix)
rem
local y_spcg%
  if rows%=0:return
  y_spcg% = 12+(y_csize%*10)
  if rows%= -1
    if ysize%= -1
      rows%=(maxy%-14-app_y_orig%) div y_spcg% : rem max nbr of rows
    else
      rows%= (ysize%-app_y_orig%-4) div y_spcg%
    endif
  endif
  if rows%=0:rows%=1
  ysize%=rows%*y_spcg%+app_y_orig%+4
  if ysize%>=maxy%-14
    ysize%=maxy%-app_y_orig%-14
    rows%=ysize% div y_spcg%
    ysize%=rows%*y_spcg% + app_y_orig% + 4
  endif
end def calc_ysize
:
