DEFine FuNction make_all_months$
rem this makes a string "JanFeb..." in the current language
rem this should be called during the initialisation part
rem eg. all_months$=make_all_months$ - dates_init below is a handy proc for that
LOCal string$,lp%,a$,temp
  string$="":a$="":temp=0
  temp=60*60*24*31
  FOR lp%=0 TO 11
    a$=DATE$(lp%*temp)
    string$=string$&a$(6 TO 8)
  END FOR lp%
  RETurn string$
END DEFine make_all_months$
:
DEFine FuNction make_date$(dflag%,what_date)
rem returns date as "01.01.1991" (dflag%=1) or "1991.01.31" (dflag%=0)
rem if what_date<>0, then it is this date that will be returned
rem this presumes that a variable "all_month$" exists!
  LOCal a$,b$,res
  b$=""
  IF what_date
    a$=DATE$(what_date) 	: rem make date passed as param into string
  ELSE
    a$=DATE$			: rem current date into string
  END IF
  b$=a$(6 TO 8) 		: rem 3 letter month abbreviation
  res= b$ INSTR all_months$		: rem find it
  IF NOT res
       all_months$=make_all_months$	: rem not found?, make all_month$
       res= b$ INSTR all_months$	: rem and retry
  END IF
  res=(res+2)/3 		: rem this is the month in figures
  b$=res:IF res<10:b$="0"&b$		: rem add leading 0 if necessary
  IF dflag%:RETurn a$(10 TO 11)&"."&b$&"."&a$(1 TO 4)
  RETurn a$(1 TO 4)&"."&b$&"."&a$(10 TO 11)
END DEFine make_date$
:
DEFine FuNction make_date_as_long (mydate$)
rem This returns a date (stripped of time!) as a long int.
rem The date is either the date given in mydate$ param (format: YYYY.MM.DD)
rem or the current date if mydate$="".
LOCal a$,year,month,day
  if mydate$=""
    a$=make_date$(0,0)
  else
    a$=mydate$
  endif
  year=a$(1 TO 4)
  month=a$(6 TO 7)
  day=a$(9 TO 10)
  RETurn MKDATE(year,month,day,0,0,0)
END DEFine make_current_date
:
DEFine FuNction make_day_and_month$(my_date)
REMark returns the date passed as parameter, or the current date if param=0
rem in the form 1er octobre 2002
rem this presumes that the vars all_months$ and mois$ have been initialised
LOCal a$,b$,res,c$
  if my_date
    a$=date$(my_date)
  else
    a$=DATE$
  endif
  c$=a$(1 to 4) 			: rem year
  b$=a$(6 TO 8) 			: rem extract month
  res= b$ INSTR all_months$		: rem get number of month...
  res=(res+2)/3 			: rem ... now
  a$=a$(10 to 11)			: rem extract day
  if a$(1)="0":a$=a$(2) 		: rem strip leading 0
  if a$="1":a$="1er"			: rem 1 is special case: 1 -> 1er
  RETurn a$&" "&mois$(res)&' '&c$	: rem return as 2 october 2002 etc
END DEFine make_day_and_month$
:
def proc dates_init
rem this initilises some variables that have to do with dates
  all_months$=make_all_months$
  DIM mois$(12,10)
  mois$(1)="Janvier":mois$(2)="Fvrier"
  mois$(3)="Mars":mois$(4)="Avril":mois$(5)="Mai":mois$(6)="Juin"
  mois$(7)="Juillet":mois$(8)="Aot":mois$(9)="Septembre"
  mois$(10)="Octobre":mois$(11)="Novembre":mois$(12)="Dcembre"
end def dates_init
:
def fn convert_date_to_mine (ddate)
rem This converts a QL system date to "mine", eg. one to be used with LONG$.
rem It returns the long word of "my" date. The QL system date is thus
rem stripped of all time info.
rem This PRESUMES that a global var, named all_months$ exists, containing
rem the first three chars of each months (eg as retuened bu the QL date$ function)
rem exists. This var may be set up with the function below.
local a$,my$,md$,mm$,mdatex,t%
  a$=date$(ddate)			: rem convert to string
  my$=a$(1 to 4)			: rem year
  md$=a$(10 to 11)			: rem day
  mm$=a$(6 to 8)
  t%=mm$ instr all_months$
  if not t%:return 0			: rem huh?
  t%=(t% div 3) + 1
  mm$=t%:if len(mm$)=1:mm$="0"&mm$
  a$=my$&mm$&md$
  mdatex=a$
  return mdatex
end def convert_date_to_mine
:
